/******************************************************************************

     ()
 .       v. 1.0

(c) 2002                 <xstazz@hotbox.ru>

               http://vt.spbgmtu.ru

******************************************************************************/

public class LinearSolveGaussColLead
{
  public void solve(double a[][], //  
                    double x[])   // 
  {
    // 
    int n = x.length;
   double eps = 0.000001;

    // 
    for(int k=0; k<n; k++)
    {
       //      
       double max = 0;
       int max_i = -1;

       for(int i=k; i<n; i++)
       {
          if(Math.abs(a[i][k]) > max)
          {
             max = Math.abs(a[i][k]);
             max_i = i;
          }
       }
       if(max_i == -1 || Math.abs(a[max_i][k])<eps)
       {
          System.out.println(":   ");
          return;
       }
       else
       {
          if(max_i != k)
          {
             // 
             for(int j=0; j<n+1; j++)
             {
               double t = a[max_i][j];
               a[max_i][j] = a[k][j];
               a[k][j] = t;
             }
          }
       }

       // 
       double lead = a[k][k];

       for(int j=k; j<n+1; j++)
       {
          a[k][j] /= lead;
       }

       for(int i=k+1; i<n; i++)
       {
          double a_div_lead = a[i][k]/a[k][k];

          for(int j=k; j<n+1; j++)
          {
             a[i][j] -= a[k][j]*a_div_lead;
          }
       }
    }

    // 
    x[n-1] = a[n-1][n];

    for(int k=n-2; k>=0; k--)
    {
       double sum = a[k][n];

       for(int j=k+1; j<n; j++)
       {
          sum -= a[k][j]*x[j];
       }

       x[k] = sum;
    }
  }
}
