/******************************************************************************

     ()
 .       v. 1.0

(c) 2002                 <xstazz@hotbox.ru>

               http://vt.spbgmtu.ru

******************************************************************************/

import java.io.*;

public class Main
{
  static double a[][];
  static double x[];
  static int n;

  public static void main(String args[])
  {
    String inFileName = "indata.txt";
    String outFileName = "outdata.txt";

    readData(inFileName);

    LinearSolveGaussColLead ls = new LinearSolveGaussColLead();
    ls.solve(a, x);                     //   

    writeData(outFileName);

    System.out.println(" :  " + inFileName);
    System.out.println(" : " + outFileName);
    System.out.println(" ");
  }

  public static void readData(String fileName)
  {
    try
    {
      InputStream inStream = new FileInputStream(fileName);
      StreamTokenizer streamTok = new StreamTokenizer(inStream);

      streamTok.parseNumbers();

      int res = streamTok.nextToken();
      if(res != streamTok.TT_EOF && res == streamTok.TT_NUMBER)
      {
        n = (new Double(streamTok.nval).intValue());
        a = new double[n][n+1];
        x = new double[n];
      }
      else
      {
        throw new IOException();
      }

      res = streamTok.nextToken();
      for(int i = 0; i<n; i++)
      {
        for(int j = 0; j<n+1; j++)
        {
          if(res != streamTok.TT_EOF && res == streamTok.TT_NUMBER)
          {
            a[i][j] = streamTok.nval;
            res = streamTok.nextToken();
          }
          else
          {
            throw new IOException();
          }
        }
      }

      inStream.close();
    }
    catch(FileNotFoundException e)
    {
      System.out.println("   ");
    }
    catch(IOException e)
    {
      System.out.println("   ");
    }
  }

  public static void writeData(String fileName)
  {
    try
    {
      OutputStream outStream = new FileOutputStream(fileName);
      PrintStream printStream = new PrintStream(outStream);

      for(int i = 0; i<n; i++)
      {
        printStream.println(x[i]);
      }

      outStream.close();
    }
    catch(FileNotFoundException e)
    {
      System.out.println("   ");
    }
    catch(IOException e)
    {
      System.out.println("    ");
    }
  }
}